<template>
  <div class="section">
    <div v-if="$apollo.loading">Loading...</div>
    <div v-else class="container">
      <div class="columns is-centered">
        <div class="column is-two-thirds">
          <div class="columns box">
            <div class="column is-half">
              <div class="box">
                <article class="media">
                  <div class="media-left">
                    <figure class="image is-92x92">
                      <img :src="profileImageUrl" :alt="`${User.firstname} ${User.lastname}`">
                    </figure>
                  </div>
                  <div class="media-content">
                    <div class="content">
                      <p>
                        <strong>{{ User.firstname }} {{ User.lastname }}</strong>&nbsp;&nbsp;<small>@{{ User.username }}</small>
                        <br>
                        {{ User.bio }}
                      </p>
                    </div>
                  </div>
                </article>
              </div>
            </div>
            <div class="column is-half">
              <h3 class="subtitle">Equipment Details</h3>
              <hr>
              <strong>Camera:</strong>&nbsp;{{ User.camera.make }} {{ User.camera.model }} <br>
              <strong>Lens:</strong>&nbsp; <span v-for="(lens, index) in User.camera.lens" :key="index">{{ lens }}</span> <br>
              <strong>Accessories:</strong>&nbsp;<b-tag v-for="(accessory, index) in User.camera.accessories" :key="index + 2 * 5 " type="is-info">{{ accessory }}</b-tag>
            </div>
          </div>
        </div>
      </div>
      <hr>
      <br>
      <div class="columns is-multiline">
        <div class="column is-3" v-for="image in User.images" :key="image.id">
          <router-link :to="`/image/${image.id}`">
            <figure class="image is-4x3">
              <img :src="imageUrl(image.path)" :alt="image.title">
            </figure>
          </router-link>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import USER_QUERY from '@/graphql/User/User.gql'
export default {
  apollo: {
    User: {
      query: USER_QUERY,
      variables () {
        return {
          username: this.$route.params.username
        }
      }
    }
  },
  computed: {
    profileImageUrl () {
      return `${this.$store.state.cloudinary}/w_100,h_100,c_thumb,g_face,f_auto,q_auto/${this.User.profileImage}`
    }
  },
  methods: {
    imageUrl (path) {
      return `${this.$store.state.cloudinary}/w_300,h_200,c_fill,f_auto,q_auto/${path}`
    }
  }
}
</script>

<style lang="scss" scoped>
  .subtitle {
    margin: unset !important;
  }
  hr {
    margin: 0.8rem !important;
  }

  .tag {
    margin-right: 0.5rem;
  }
</style>
